# See ".env" file for environment variabls used.

version: '3.8'

services:
  mongo:
    image: mongo:latest
    networks:
      - mdbook-dev

  part_i_generator:
    depends_on:
      - mongo
    image: ${PART_I_GENERATOR_DOCKER_IMAGE}
    volumes:
      - shared-volume:/home/node
    entrypoint: >
      /bin/bash -c "git clone --branch ${SCRIPTS_TAG_OR_BRANCH} ${SCRIPTS_BASE_REPO_URL}${SCRIPTS_REPO_NAME}.git;
      git clone --branch ${MTTL_TAG_OR_BRANCH} ${MTTL_BASE_REPO_URL}${MTTL_REPO_NAME}.git;
      git clone --branch ${MDBOOK_TAG_OR_BRANCH} ${MDBOOK_BASE_MODULE_URL}${MDBOOK_MODULE}.git;
      cd mttl; 
      MONGO_HOST=${MONGO_HOST} ./scripts/before_script.sh;
      cd .. ;
      mkdir -p ${MDBOOK_MODULE}/scripts;
      cp -R scripts ${MDBOOK_MODULE};
      cd ${MDBOOK_MODULE};
      pip3 install jinja2 pymongo;
      MONGO_HOST=${MONGO_HOST} python3 scripts/generate_part_i.py ${MDBOOK_MODULE};"
    
    networks:
      - mdbook-dev

  mdbook:
    depends_on:
      - part_i_generator

    image: ${MDBOOK_DOCKER_IMAGE}
    # stdin_open: true # docker run -i
    # tty: true        # docker run -t
    # user: 0:0  # makes the user root which is needed to be able to write to the volumes
    ports:
      - "${MDBOOK_MODULE_SERVED_PORT_HOST}:${MDBOOK_MODULE_SERVED_PORT_CONTAINER}"
    # TODO: normal container side port (3000) to be exposed to a random port 
    # on the host side so multiple module containers can run at the same time
    # this can easily be done but it is not not easy to have browser spawned to this random port
    volumes:
      - shared-volume:/home/mdbook
    entrypoint: >
        /bin/bash -c "mkdir -p ~/build/${MDBOOK_MODULE};
        mkdir -p .vscode;
        git clone --branch ${MDBOOK_TAG_OR_BRANCH} ${MDBOOK_BASE_MODULE_URL}${MDBOOK_MODULE}.git;
        cd ${MDBOOK_MODULE};
        cat .env >> ~/.bashrc;
        cp .devcontainer/.vscode_staging/* ~/.vscode;
        cd mdbook;
        mdbook serve --dest-dir ~/build/${MDBOOK_MODULE} --port ${MDBOOK_MODULE_SERVED_PORT_CONTAINER} --hostname ::";
    networks:
      - mdbook-dev


      
# git clone git@gitlab.com:39iosdev/ccd-iqt/idf/assembly.git;
networks:
  mdbook-dev:

volumes:
  shared-volume:
#   mdbook-dev-builder: